<template>
  <div class="registration">
    <div class="form-wrap">
      <h2>Регистрация</h2>
      <form method="post" @submit.prevent="checkForm">
        <div>
          <input
            class="form-control" 
            v-model.trim="form.name" 
            placeholder="Имя">
          <p 
            class="invalid-feedback " 
            :class="$v.form.name.$error ? 'is-invalid' : ''" 
            v-if="$v.form.name.$dirty && !$v.form.name.required"
          >
          Обязательное поле!
          </p>
        </div>
        <div>
          <input 
            :class="$v.form.surname.$error ? 'is-invalid' : ''" 
            class="form-control" 
            v-model.trim="form.surname"
            placeholder="Фамилия">
          <p 
            class="invalid-feedback" 
            :class="$v.form.surname.$error ? 'is-invalid' : ''" 
            v-if="$v.form.surname.$dirty && !$v.form.surname.required"
          >
          Обязательное поле!
          </p>
        </div>
        <div>
          <input 
            class="form-control" 
            v-model.trim="form.email"
            placeholder="Адрес электронной почты">
          <p 
            class="invalid-feedback" 
            :class="$v.form.email.$error ? 'is-invalid' : ''" 
            v-if="$v.form.email.$dirty && !$v.form.email.required"
          >
          Обязательное поле!
          </p>
          <p 
            class="invalid-feedback" 
            :class="$v.form.email.$error ? 'is-invalid' : ''" 
            v-if="$v.form.email.$dirty && !$v.form.email.email"
          >
          Не верные данные!
          </p>
        </div>
        <div>
          <input
            class="form-control"
            v-model.trim="form.password"
            placeholder="Пароль">
          <p 
            class="invalid-feedback" 
            :class="$v.form.password.$error ? 'is-invalid' : ''" 
            v-if="$v.form.password.$dirty && !$v.form.password.required"
          >
          Обязательное поле!
          </p>
          <p 
            class="invalid-feedback" 
              :class="$v.form.password.$error ? 'is-invalid' : ''" 
              v-if="$v.form.password.$dirty && !$v.form.password.minLength"
          >
          Количество символов не менее 8!
          </p>
        </div>
        <button type="submit">Отправить</button>
      </form>
    </div>
  </div>
</template>


<script>
import { validationMixin } from 'vuelidate'
import { required, minLength, email } from 'vuelidate/lib/validators'

export default {
  name: "registration",
  mixins: [validationMixin],
  data() {
    return {
      form: {
      name: '',
      surname: '',
      email: '',
      password: ''
      }
    }
  },
  validations: {
    form: {
      name: { required },
      surname: { required },
      email: { required, email },
      password: { required, minLength: minLength(8) }
    }
  },
  methods: {
    checkForm() {
      this.$v.form.$touch()
      if (!this.$v.form.$error){
        console.log('Валидация прошла успешно')
      }
    }
  }
}

</script>


<style lang="scss">
.registration {
  height: 100vh;
  display: flex;
  align-items: center;
  justify-content: center;
  background-image: url(../../assets/images/original.jpg);
  object-fit: inherit;
  background-position: center;
  opacity: 0.9;
}

.is-invalid{
  color: red;
}

.form-wrap {
  background: #fff;
  border-radius: 8px;
  border: 2px solid #aeaeae;

  h2 {
    text-align: center;
    padding-top: 20px;
  }

  form {
    padding: 30px 20px 60px;
    display: flex;
    flex-direction: column;

    div:not(:last-child){
    margin-bottom: 10px;
  }

    input {
      display: block;
      width: 400px;
      padding: 8px;
      border-radius: 4px;
      border: none;
      border: 2px solid #aeaeae;
    }
  }

  button {
    width: 400px;
    padding: 9px 0;
    background: #269815;
    border: 1px solid #269815;
    margin-top: 20px;
    border-radius: 2px;
  }
}
</style>